<?php 
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 					____________________						   *
 * 					 WAnewsletter 2.0.0							   *
 * 											   *
 * 		Fichier 	:		fonctions.inc.php					   *
 * 		Cr le 	:		27 mars 2002						   *
 * 		Dernire modif :	13 aut 2002						   *
 * 		Email		: 		wascripts@phpcodeur.net				   *
 * 		Version		:		2.0.0								   *
 * 			 Copyright 2002 PHPcodeur							   *
 * 							  									   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *																   *
 *  This program is free software; you can redistribute it and/or  *
 * 	modify it under the terms of the GNU General Public License as *
 * 	published by the Free Software Foundation; either version 2 of *
 *  the License, or (at your option) any later version.			   *
 * 																   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


//
// vrification de la validit de l'email donn.
//
// note : Obtenu sur phpinfo.net, section trucs et astuces.
//
function EmailOK($email) 
{ 
	return ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'.
				'@'.'[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.
				'[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $email ); 
}

//
// Retourne un identifiant unique.
//
function get_code()
{    
    return substr( md5( uniqid( rand() ) ), 0, 16); 
} 

//
// Fonction de retour de messages d'informations ou d'erreur sur l'admin.
//
function message($type, $text, $title = '', $link = '')
{
	global $lang, $newsletter_config, $meta;
	
	$template = new Template('../templates/');	
	
	switch($type)
	{
		case GENERAL_ERROR:
			define('MENU', FALSE);
			include('page_header.php');
			
			$template->set_filenames( array('error' => 'general_error.tpl'));
			
			$template->assign_vars( array(
				'GENERAL_TITLE' => 'Administration de la newsletter', 
				'TITLE' => ( $title == '' ) ? '<font color="red">Erreur g&eacute;n&eacute;rale !</font>' : '<font color="red">' . $title . '</font>', 
				'MSG' => $text 
			));
		break;
		
		case ERROR:
			define('MENU', TRUE);
			include('page_header.php');
			
			$template->set_filenames( array('error' => 'error.tpl'));
			
			$template->assign_vars( array(
				'TITLE' => ( $title == '' ) ? '<font color="red">' . $lang['title_error'] . '</font>' : '<font color="red">' . $title . '</font>', 
				'MSG' => $text 
			));			
		break;
		
		case INFO:
			define('MENU', TRUE);
			include('page_header.php');
			
			$template->set_filenames( array('error' => 'error.tpl'));
			
			$template->assign_vars( array(
				'TITLE' => ( $title == '' ) ? '<font color="green">' . $lang['title_info'] . '</font>' : '<font color="green">' . $title . '</font>', 
				'MSG' => $text 
			));
		break;
	}
	
	if( $link != '' )
	{
		$template->assign_block_vars('link', array('LINK' => $link ));
	}
	
	$template->pparse('error');
	
	include('page_footer.php');
	
	exit;
}

//////////////////////////////////////////////////////////////
//
// Fonctions utilises pour les sessions sur l'administration.
//

//
// Gnration d'un identifiant de session
//
function generate_session_id($var)
{
	return md5( uniqid( $var ) ); 
}

//
// Ouverture d'une session.
//
// session_open prend l'identifiant de l'utilisateur comme argument.
//
function session_open($admin_id)
{
	global $newsletter_config, $HTTP_COOKIE_VARS, $HTTP_GET_VARS, $sid;
	
	if( isset($HTTP_COOKIE_VARS['wanewsletter_test']) )
	{
		$method = 'COOKIE';
	}
	else
	{
		$method = 'GET';
	}
	
	$sql = "SELECT * FROM " . ADMIN . " WHERE admin_id = '$admin_id'";
	
	$result = mysql_query($sql);
	if( !$result )
	{
		message(GENERAL_ERROR, 'Impossible d\'obtenir les informations sur l\'utilisateur');
	}
	
	$admindata = mysql_fetch_array($result);
	$starttime = time();
	$session_id = generate_session_id($admindata['user']);
	
	$sql = "UPDATE " . SESSIONS . " 
			SET session_id = '$session_id', session_start = '$starttime', session_time = '$starttime' 
			WHERE admin_id = '$admin_id'";	
	$result = mysql_query($sql);
	
	if( !mysql_affected_rows() )
	{	
		$sql = "INSERT INTO " . SESSIONS . " (session_id, admin_id, session_start, session_time) 
				VALUES('$session_id','$admin_id','$starttime','$starttime')";	
		$result = mysql_query($sql);
		if ( !$result )
		{
			message(GENERAL_ERROR, 'Impossible de dmarrer la session');
		}
	}	
	
	if( $method == 'COOKIE' )
	{		
		setcookie("wanewsletter_test", "1", time() - 99999, "/");
		setcookie("wanewsletter_sessid", $session_id, time() + 99999, "/");
	}
	else if( $method == 'GET' )
	{
		$sid = 'sessid=' . $session_id;
	}
	
	return $admindata;
}

//
// Vrification de l'existence d'une session grce  l'identifiant de session
// obtenu par dfaut via le cookie, ou, si les cookies ne sont pas accepts par le navigateur, 
// via l'url.
//
function session_verif()
{
	global $newsletter_config, $lang, $HTTP_COOKIE_VARS, $HTTP_GET_VARS, $sid;
	
	if( isset($HTTP_COOKIE_VARS['wanewsletter_sessid']) )
	{
		$session_id = $HTTP_COOKIE_VARS['wanewsletter_sessid'];
		$method = 'COOKIE';
	}
	else if( isset($HTTP_GET_VARS['sessid']) )
	{
		$session_id = $HTTP_GET_VARS['sessid'];
		$method = 'GET';
	}
	else
	{
		return false;
	}
	
	$time = time();
	
	$sql = "UPDATE " . SESSIONS . " 
			SET session_time = '$time' 
			WHERE session_id = '$session_id'";
	$result = @mysql_query($sql);
	if ( !$result )
	{
		message(GENERAL_ERROR, 'Impossible de mettre  jour la session');
	}
	
	$sql = "SELECT a.admin_id, a.user, a.passwd, a.email, a.droits, s.session_id, s.admin_id, s.session_start, s.session_time 
			FROM " . ADMIN . " AS a, " . SESSIONS . " AS s 
			WHERE a.admin_id = s.admin_id AND s.session_id = '$session_id'";	
	$result = mysql_query($sql);
	
	if( !$result )
	{
		message(ERROR, 'Impossible d\'obtenir des informations sur la session et sur l\'utilisateur');
	}
	
	if( !mysql_num_rows($result) )
	{
		return false;
	}
	
	$admindata = mysql_fetch_array($result);	
	
	$intervalle = $admindata['session_time'] - $admindata['session_start'];
	
	if( $intervalle > $newsletter_config['session_duree'] )
	{
		$sql = "DELETE FROM " . SESSIONS . " WHERE session_id = '$session_id'";
		mysql_query($sql);
		return false;
	}
	
	if( $method == 'GET' )
	{
		$sid = 'sessid=' . $session_id;
	}
	
	return $admindata;
}

//
// Fermeture de la session en cours.
//
function session_close()
{
	global $newsletter_config, $HTTP_COOKIE_VARS, $HTTP_GET_VARS, $sid;
	
	if( isset($HTTP_COOKIE_VARS['wanewsletter_sessid']) )
	{
		$session_id = $HTTP_COOKIE_VARS['wanewsletter_sessid'];
		setcookie("wanewsletter_sessid", "", time() - 99999, "/");
		$method = 'COOKIE';
	}
	else if( isset($HTTP_GET_VARS['sessid']) )
	{
		$session_id = $HTTP_GET_VARS['sessid'];
		$method = 'GET';
	}
	
	$sql = "DELETE FROM " . SESSIONS . " WHERE session_id = '$session_id'";
	mysql_query($sql);	
}

//
// Ajout de l'identifiant de session s'il est transmis par l'url.
//
function sessid($url)
{
	global $sid;
	
	if ( $sid != '' AND !ereg('sessid=', $url) )
	{
		$url .= ( ( strpos($url, '?') ) ?  '&' : '?' ) . $sid;
	}

	return($url);
}

//
// Fin des fonctions de session.
//
//////////////////////////////////////////////////////////////


//
// Fonction d'affichage par page.
//
// $url -> adresse vers laquelle doivent pointer les liens de navigation
// $total_num -> nombre total d'lments  afficher
// $num_per_page -> nombre d'lments par page
// $page_id -> identifiant de la page en cours
//
function navigation($url, $total_num, $num_per_page, $page_id)
{
	global $lang;
	
	$total_pages = ceil($total_num / $num_per_page);
	
	$url = ( strpos($url, "?") ) ? $url . '&amp;' : $url . '?';
	
	if( $total_pages == 1 )
	{
		return '';
	}
	
	$nav_string = '';
		
	if( $total_pages > 10 )
	{
		$prev = ( substr($page_id - 1, 0, 1) . '1' ) - 1 ;		
		
		if( $page_id > 10 )
		{
			$nav_string .= '<a href="' . $url . 'page=' . $prev . '">precdent</a> &nbsp;&nbsp;';
		}
		
		if( strlen($page_id) == 1 OR $page_id == 10 )
		{
			$current = 1 ;
			$next = 11 ;
		}
		else
		{
			$current = ( ( substr($page_id - 1, 0, 1) . '1' ) == '01' ) ? '1' : ( substr($page_id - 1, 0, 1) . '1' );
			$next = ( substr($page_id - 1, 0, 1) . '1' ) + 10 ;
		}
		
		for( $i = $current; $i < $current + 10; $i++ )
		{
			if( $i < $total_pages + 1 )
			{
				$nav_string .= ( $i == $page_id ) ? '<b>' . $i . '</b>' : '<a href="' . $url . 'page=' . $i . '">' . $i . '</a>';
				if ( $i <  $current + 9 AND $i < $total_pages )
				{
					$nav_string .= ', ';
				}
			}			
		}
		
		if( $total_pages > $next )
		{
			$nav_string .= '&nbsp;&nbsp; <a href="' . $url . 'page=' . $next . '">suivant</a>';
		}
	}
	else
	{
		for( $i = 1; $i < $total_pages + 1; $i++ )
		{
			$nav_string .= ( $i == $page_id ) ? '<b>' . $i . '</b>' : '<a href="' . $url . 'page=' . $i . '">' . $i . '</a>';

			if ( $i <  $total_pages )
			{
				$nav_string .= ', ';
			}
		}
	}
	
	return $nav_string;
}

//
// Fonction de renvoi de date selon la langue
//
// variables d'entre : 
// $timestamp = contient le timestamp  convertir
// 
// variables de sorties : 
// 
// la fonction retourne un tableau contenant les donnes suivantes :
// L'anne, le mois en chiffre, en lettres, le jour en chiffres, en lettres, 
// l'heure, les minutes, et les secondes.
//
function convert_time($timestamp)
{
	global $lang;
	
	$string = date("Y/m/j/w/H/i/s", $timestamp);
	$elt = explode("/", $string); 
	
	$date['year'] = $elt[0];
		
	switch($elt[1])
	{
		case "01": 
			$mois = $lang['janvier'];
			break;
		
		case "02": 
			$mois = $lang['fevrier'];
			break;
		
		case "03": 
			$mois = $lang['mars'];
			break;
		
		case "04": 
			$mois = $lang['avril'];
			break;
		
		case "05": 
			$mois = $lang['mai'];
			break;
		
		case "06": 
			$mois = $lang['juin'];
			break;
		
		case "07": 
			$mois = $lang['juillet'];
			break;
		
		case "08": 
			$mois = $lang['aout'];
			break;
		
		case "09": 
			$mois = $lang['sept'];
			break;
		
		case "10": 
			$mois = $lang['oct'];
			break;
		
		case "11": 
			$mois = $lang['nov'];
			break;
		
		case "12": 
			$mois = $lang['dec'];
			break;
	}
	
	$date['string_month'] = $mois;
	$date['num_month'] = $elt[1];
	$date['num_day'] = $elt[2];
	
	switch($elt[3])
	{
		case "0": 
			$elt[3] = $lang['dimanche'];
			break;
		
		case "1": 
			$elt[3] = $lang['lundi']; 
			break;
		
		case "2": 
			$elt[3] = $lang['mardi']; 
			break;
		
		case "3": 
			$elt[3] = $lang['mercredi']; 
			break;
		
		case "4": 
			$elt[3] = $lang['jeudi']; 
			break;
		
		case "5": 
			$elt[3] = $lang['vendredi']; 
			break;
		
		case "6": 
			$elt[3] = $lang['samedi']; 
			break;
	}
	
	$date['string_day'] = $elt[3];
	$date['hour'] = $elt[4];
	$date['minutes'] = $elt[5];
	$date['seconds'] = $elt[6];
	
	return $date;
}
?>